<?php
/**
 * @version 1.0 $Id: select.php 175 2009-11-07 10:24:30Z vistamedia $
 * @package Joomla
 * @subpackage FLEXIcontent
 * @subpackage plugin.select
 * @copyright (C) 2009 Emmanuel Danan - www.vistamedia.fr
 * @license GNU/GPL v2
 *
 * FLEXIcontent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */
defined( '_JEXEC' ) or die ( 'Restricted access' );

jimport('joomla.event.plugin');

class plgFlexicontent_fieldsKcomment extends JPlugin {

	static $includedCss = false;
	var $Dbo;
	var $User;
	var $KUser;
	var $KLogin;
	var $KConfig;
	var $App;
	var $Uri;
	var $Doc;
	var $_debug = false;

	function plgFlexicontent_fieldsKcomment( &$subject, $params ) {
		parent::__construct( $subject, $params );
		require_once (KUNENA_PATH . DS . 'class.kunena.php');
		require_once (KUNENA_PATH . DS . 'lib/kunena.link.class.php');
		require_once (KUNENA_PATH . DS . 'lib/kunena.posting.class.php');
		require_once (KUNENA_PATH . DS . 'funcs/view.php');
		require_once (KUNENA_PATH . DS . 'funcs/post.php');
		// Load language files
    $this->loadLanguage ('plg_flexicontent_fields_kcomment', JPATH_ADMINISTRATOR);
		// load Kunena main language file so we can leverage language strings from it
		KunenaFactory::loadLanguage();
		// Initialize variables
		$this->Dbo =& JFactory::getDbo ();
		$this->User =& JFactory::getUser ();
		$this->App =& JFactory::getApplication ( 'site' );
		$this->Uri =& JFactory::getURI ();
		$this->Doc =& JFactory::getDocument ();
		$this->KUser =& KunenaFactory::getUser();
    $this->KLogin =& KunenaFactory::getLogin (); 
		$this->KConfig =& KunenaFactory::getConfig ();
		// If plugin is not enabled in current scope, do not register it
		if (! $this->enabled ()){
		  $this->debug ( "Plugin non activ !" );
  		return null;
    } 
		// Kunena detection and version check
		$minKunenaVersion = '1.6.2';
		if (!class_exists('Kunena') || Kunena::versionBuild() < 3892) {
			$this->App->enqueueMessage( JText::sprintf ( 'PLG_KUNENADISCUSS_DEPENDENCY_FAIL', $minKunenaVersion ) );
			return null;
		}
		// Kunena online check
		if (!Kunena::enabled()){
		  $this->debug ( "Kunena non activ !" );
  		return null;
    }
		$this->debug ( "Constructor called in " . $this->App->scope );
	}

  // ---------------------------------------------------
  // Begin of standard plugin callback function
  // ---------------------------------------------------
	function onDisplayField(&$field, &$item) {
		// execute the code only if the field type match the plugin type
    $this->debug("Call of onDisplayField");
		if($field->field_type != 'kcomment'){
		  $this->debug ("Rejet appel onDisplayField car type incorrect !");
		  return;
    }
		// some parameter shortcuts
		$required = $field->parameters->get( 'required', 0 ) ;
		$field_kforumcatid = $field->parameters->get( 'field_kforumcatid' ) ;
		$default_kforumid	= $field->parameters->get( 'default_kforumid' ) ;						
		$required = $required ? 'class="required"' : null;
		// initialise property
		if(!$field->value || $field->value[0] == '') {
			$field->value[0] = $default_kforumid;
		}	
		$query = "select id, name from #__kunena_categories where parent={$field_kforumcatid}";
		$this->Dbo->setQuery($query);
		$results = $this->Dbo->loadObjectList();		
		if (!$results) {
			$field->html = JText::_('FLEXI_FIELD_INVALID_QUERY');		
		} else {		
			$options = array();
			foreach($results as $result) {
				$options[] = JHTML::_('select.option', $result->id, $result->name);
			}
			$field->html	= JHTML::_('select.genericlist', $options, $field->name, $required, 'value', 'text', $field->value);
		}		
	}

	function onBeforeSaveField( &$field, &$post, &$file ) {
		// execute the code only if the field type match the plugin type
    $this->debug("Call of onBeforeSaveField");
		if($field->field_type != 'kcomment'){
		  $this->debug ("Rejet appel onBeforeSaveField car type incorrect !");
		  return;
    } 
		if(!$post) return;			
		$searchindex .= '';
		$field->search = $field->issearch ? $searchindex : '';		
	}

	function onDisplayFieldValue(&$field, &$item, $values=null, $prop='display') {
		// execute the code only if the field type match the plugin type
    $this->debug("Call of onDisplayFieldValue");
		if($field->field_type != 'kcomment'){
		  $this->debug ("Rejet appel onDisplayFieldValue car type incorrect !");
		  return;
    } 
		$values = $values ? $values : $field->value ;
		if (isset($values[0])) {
			$display = $this->showKComment($field, $item, $values[0]);
		} else {
			$display = '';
		}
		$field->{$prop}	= $display;
	}

	function onDisplayFilter(&$filter, $value='') {
		// execute the code only if the field type match the plugin type
    $this->debug("Call of onDisplayFilter");
		if($field->field_type != 'kcomment'){
		  $this->debug ("Rejet appel onDisplayFilter car type incorrect !");
		  return;
    } 		
		$filter->html	= '';
	}
  // ---------------------------------------------------
  // End of standard plugin callback function
  // ---------------------------------------------------


	// *** internal functions follows ***
	/******************************************************************************
	 *
	 *****************************************************************************/
	function showKComment(&$field, &$item, $catId) {
		// Show a simple form to allow posting to forum from the plugin
		$plgShowForm = $field->parameters->get ( 'form', 1 );
		// Default is to put QuickPost at the very bottom.
		$formLocation = $field->parameters->get ( 'form_on_top', 0 );
    $threadId = 0;
		$quickPost = '';
		$link_topic = '';
		$content = '';
		$canPost = false;
		// Create plugin table if doesn't exist
		$query = "SHOW TABLES LIKE '%_kunenadiscuss'";
		$this->Dbo->setQuery ( $query );
		if (is_null($this->Dbo->loadResult ())) {
			CKunenaTools::checkDatabaseError ();
			$query = "CREATE TABLE IF NOT EXISTS `#__kunenadiscuss`
					(`content_id` int(11) NOT NULL default '0',
					 `thread_id` int(11) NOT NULL default '0',
					 PRIMARY KEY  (`content_id`)
					 )";
			$this->Dbo->setQuery ( $query );
			$this->Dbo->query ();
			CKunenaTools::checkDatabaseError ();
			$this->debug ( "Created #__kunenadiscuss cross reference table." );
		} else {
  		// Find cross reference and the real topic
  		$query = "SELECT d.content_id, d.thread_id, m.id AS mesid, t.thread, t.time
  			FROM #__kunenadiscuss AS d
  			LEFT JOIN #__kunena_messages AS m ON d.thread_id = m.id
  			LEFT JOIN #__kunena_messages AS t ON t.id = m.thread
  			WHERE d.content_id = {$this->Dbo->quote($item->id)}";
  		$this->Dbo->setQuery ( $query );
  		$result = $this->Dbo->loadObject ();
  		CKunenaTools::checkDatabaseError ();
  		if (is_object($result)) {
  			if ($result->thread != $result->thread_id) {
  				// Topic has been moved, has been deleted or tag inside message has been changed
  				$this->debug ( "showPlugin: Removing cross reference record pointing to topic {$result->thread_id}" );
  				$query = "DELETE FROM #__kunenadiscuss WHERE content_id={$this->Dbo->quote($result->content_id)}";
  				$this->Dbo->setQuery ( $query );
  				$this->Dbo->query ();
  				CKunenaTools::checkDatabaseError ();
  				// We may need to add new cross reference or create new topic
  				$result = null;
  			}
  			$threadId = $result->thread;
  		}
    }
    // Elaborate topic link
		if ($threadId) {
			$sql = "SELECT count(*) FROM #__kunena_messages WHERE hold=0 AND parent!=0 AND thread={$this->Dbo->quote($threadId)}";
			$this->Dbo->setQuery ( $sql );
			$postCount = $this->Dbo->loadResult ();
			CKunenaTools::checkDatabaseError ();
			$linktitle = JText::sprintf ( 'FCKC_KUNENADISCUSS_DISCUSS_ON_FORUMS', $postCount );
			$link_topic = CKunenaLink::GetThreadLink ( 'view', $catId, $threadId, $linktitle, $linktitle );
  	} else {
    	$link_topic = JText::_('FCKC_KUNENADISCUSS_NO_TOPIC_CREATED');
    }
		// This will be used all the way through to tell users how many posts are in the forum.
		$this->debug ( "showPlugin: Rendering discussion" );
		if ($this->isItemLayout()){
  		// Elaborate the QuickPost form
  		$canPost = $this->canPost($catId,$threadId);
  		if ($plgShowForm) {
  			if ($canPost && (JRequest::getInt ( 'kdiscussContentId', 0, 'POST' ) == $item->id)) {
  				$this->debug ( "showPlugin: Reply topic!" );
  				$quickPost = $this->replyTopic ( $field, $item, $catId, $threadId );
  			} else {
  				$quickPost = $this->showForm ( $field, $item, $canPost, $this->isGuest() );
  			}
  		}
  		$content = $link_topic . $this->showTopic ($field, $item, $catId, $threadId);
  		if ($formLocation) {
  			$content = '<div class="kunenadiscuss">' . $quickPost . "<br />" . $content . '</div>';
  		} else {
  			$content = '<div class="kunenadiscuss">' . $content . '<br />' . $quickPost . '</div>';
  		}
    } else {
		  $content = $link_topic;
    }
		// Don't repeat the CSS for each instance of this plugin in a page!
		if (! self::$includedCss) {
			$this->Doc->addStyleSheet ( KUNENA_JLIVEURL . 'plugins/flexicontent_fields/kcomment/discuss.css' );
			self::$includedCss = true;
		}		
		return $content;
	}

	/******************************************************************************
	 * Output
	 *****************************************************************************/

	function showTopic(&$field, &$item, $catId, $threadId) {
    $str='';    
    if ($threadId) {
  		// Limits the number of posts
  		$limit = $field->parameters->get ( 'limit_posts', 25 );
  		// Show the first X posts, versus the last X posts
  		$ordering = $field->parameters->get ( 'ordering_posts', 1 ); // 0=ASC, 1=DESC
  		$first = (int)!$ordering;
  		$threadOutput = new CKunenaView ( 'view', $catId, $threadId, $first, $limit+$first );
  		$threadOutput->setTemplate ( '/plugins/flexicontent_fields/kcomment' );
  		$threadOutput->ordering = $ordering ? 'DESC' : 'ASC';
  		$threadOutput->hold = 0;  
  		ob_start ();
    		$threadOutput->display ();
    		$str = ob_get_contents ();
  		ob_end_clean ();
    }		
		return $str;
	}

	function showForm(&$field, &$item, $canPost, $isGuest ) {
		if (!$canPost) {
			if ($isGuest) {
				$this->debug ( "showForm: Public posting is not permitted, show login instead" );
				$this->msg = JText::sprintf ( 'FCKC_KUNENADISCUSS_LOGIN_OR_REGISTER', '"' . $this->KLogin->getLoginURL() . '"', '"' . $this->KLogin->getRegistrationURL() . '"' );
			} else {
				$this->debug ( "showForm: Unfortunately you cannot discuss this item" );
				$this->msg = JText::_ ( 'FCKC_KUNENADISCUSS_NO_PERMISSION_TO_POST' );
			}
		}		
    // Parameters for form post...
		$this->open = $field->parameters->get ( 'quickpost_open', false );
		$this->name = $this->KUser->getName();
		$this->itemid = $item->id;
		$this->guest = $isGuest;
		$this->domidx = '-'.$item->id.'-'.$field->id;
		$this->debug ( "showForm: Rendering form" );
		ob_start ();
  		include (JPATH_ROOT . '/plugins/flexicontent_fields/kcomment/form.php');
  		$str = ob_get_contents ();
		ob_end_clean ();
		return $str;
	}

	function createReference($itemId, $threadId) {
		$query = "INSERT INTO #__kunenadiscuss (content_id, thread_id) VALUES(
			{$this->Dbo->quote($itemId)},
			{$this->Dbo->quote($threadId)})";
		$this->Dbo->setQuery ( $query );
		$this->Dbo->query ();
		CKunenaTools::checkDatabaseError ();
	}

	/******************************************************************************
	 * Functions for Create and reply to topic
	 *****************************************************************************/
	function createTopic(&$field, &$item, $catId) {
		$message = new CKunenaPosting ( $field->parameters->get ( 'topic_owner', $item->created_by ) );
		$options = array();
		$fields ['subject'] = $item->title;
		switch ($field->parameters->get('bbcode')) {
			case 'full':
				$fields ['message'] = JText::_ ( 'FCKC_KUNENADISCUSS_INTRO_ARTICLE' )."
[article=full]{$item->id}[/article]";
				break;
			case 'intro':
				$fields ['message'] = JText::_ ( 'FCKC_KUNENADISCUSS_INTRO_ARTICLE' )."
[article=intro]{$item->id}[/article]
".JText::_ ( 'FCKC_KUNENADISCUSS_LINK_ARTICLE' )."
[article=link]{$item->id}[/article]";
				break;
			case 'link':
				$fields ['message'] = JText::_ ( 'FCKC_KUNENADISCUSS_LINK_ARTICLE' )."
[article=link]{$item->id}[/article]";
				break;
			default:
				$fields ['message'] = "[article]{$item->id}[/article]";
		}
		$fields ['time'] = JFactory::getDate(isset($item->publish_up) ? $item->publish_up : 'now')->toUnix();
		$success = $message->post ( $catId, $fields, $options );
		if ($success) {
			$newMessageId = $message->save ();
		}
		// Handle errors
		if (! $success || ! $newMessageId) {
			$errors = $message->getErrors ();
			foreach ( $errors as $key => $value ) {
				$this->App->enqueueMessage ( $key . ': ' . $value, 'error' );
			}
			return false;
		}
		// Keep a cross reference of Threads we create through this plugin
		$this->createReference ( $item->id, $newMessageId );
		// We'll need to know about the new Thread id later...
		$this->debug ( __FUNCTION__ . "() end" );
		return $newMessageId;
	}
	
	function replyTopic(&$field, &$item, $catId, $threadId) {
		if (JRequest::checkToken () == false) {
			$this->App->enqueueMessage ( JText::_ ( 'COM_KUNENA_ERROR_TOKEN' ), 'error' );
			return false;
		}
		$this->isBanned();
		$this->verifyCaptcha();
		$this->checkFlood();
		if (!$threadId ) {
			$threadId = $this->createTopic ( $field, $item, $catId);
		}
		$message = new CKunenaPosting ( );
		$fields ['name'] = JRequest::getString ( 'name', $this->KUser->getName (), 'POST' );
		$fields ['email'] = JRequest::getString ( 'email', null, 'POST' );
		$fields ['subject'] = $item->title;
		$fields ['message'] = JRequest::getString ( 'message', null, 'POST' );
		$success = $message->reply ( $threadId, $fields );
		if ($success) {
			$newMessageId = $message->save ();
		}
		// Handle errors
		if (! $success || ! $newMessageId) {
			$errors = $message->getErrors ();
			foreach ( $errors as $key => $value ) {
				$this->App->enqueueMessage ( $key . ': ' . $value, 'error' );
			}
			return false;
		}
		$holdPost = $message->get ( 'hold' );
		$message->emailToSubscribers(false, $this->KConfig->allowsubscriptions && ! $holdPost, $this->KConfig->mailmod || $holdPost, $this->KConfig->mailadmin || $holdPost);
		if ($holdPost) {
			$result = JText::_ ( 'FCKC_KUNENADISCUSS_PENDING_MODERATOR_APPROVAL' );
		} else {
			$result = JText::_ ( 'FCKC_KUNENADISCUSS_MESSAGE_POSTED' );
		}
		// Redirect
		$this->App->redirect ( $this->Uri->toString (), $result );
	}

	/******************************************************************************
	 * Permission checks
	 *****************************************************************************/
	function canPost($catId, $threadId) {
		$message = new CKunenaPosting ( );
		if ($threadId) {
			return $message->reply ( $threadId );
		} else {
			return $message->post ( $catId );
		}
	}

	function isGuest() {
		return ($this->User->id)?false:true;
	}

	function isBanned() {
		$post = new CKunenaPost();
		return $post->isUserBanned();
	}

	function checkFlood() {
		$post = new CKunenaPost();
		return $post->floodProtection();
	}

	function displayCaptcha() {
		$post = new CKunenaPost();
		$post->displayCaptcha();
	}

	function verifyCaptcha() {
		$post = new CKunenaPost();
		return $post->verifyCaptcha();
	}

	function enabled() {
		if ($this->App->scope == 'com_flexicontent') return true;
		return false;
	}
	
  function isItemLayout(){
    if (JRequest::getVar('view', null) == 'items') return true;
    return false;
  }
	
	function debug($msg) {
		if ($this->_debug) echo "<br />[KunenaDiscuss debug: $msg ]";			
	}

}